var ToolTips = Class.create();
ToolTips.prototype = {
	initialize:function(tgt) {
		if (!tgt) tgt = document.body;
		this.tips = document.createElement('div');
		this.tips.className = 'tooltips';
		tgt.appendChild(this.tips);
		Element.setStyle(this.tips,{ position:"absolute",left:"0px",top:"0px",zIndex:"9999" });
		Element.hide(this.tips);
	},
	initEvent:function(tgt,text) {
		if (!tgt || !text) return;
		tgt.tips = text;
		Event.observe(tgt,'mouseover',this.showTips.bindAsEventListener(this));
		Event.observe(tgt,'mouseout',this.hideTips.bindAsEventListener(this));
	},
	showTips:function(e) {
		if (e) {
			var tgt = Event.element(e);
			while (!(this.tips.innerHTML = tgt.tips)) {
					tgt = tgt.up();
					if (tgt == document.body) break;
			}

			var vp = document.viewport.getDimensions();
			var so = document.viewport.getScrollOffsets();
			var tips = Element.getDimensions(this.tips);
			var pos = tgt.getBoundingClientRect();
			var size = Element.getDimensions(tgt);
			var x = Number(pos.left);
			var y = Number(pos.top)+so[1];
			if (x - Number(tips.width) < 0) {
					y += 16; 
			} else if (Number(vp.width) > x + Number(size.width) + Number(tips.width) + 2) {
				x += Number(size.width) + 2;
			} else {
				x -= Number(tips.width) + 6;
			}
			Element.setStyle(this.tips,{ left:String(x)+"px", top:String(y)+"px" });
		}
		Element.show(this.tips);
		this.timer = new PeriodicalExecuter(function(v) { this.hideTips() }.bind(this),this.autoHide);
	},
	autoHide: 3,
	hideTips:function() {
		Element.hide(this.tips);
		if (this.timer) {
			this.timer.stop();
			this.timer = '';
		}
	}
};
